data = []


def limit(val):
	if not -0x80000000 <= val <= 0x7fffffff:
		val = (val + 0x80000000) % 0x100000000 - 0x80000000
	return val

def hash(s):
	h = 5381
	for c in s:
		h = limit((h*33) + ord(c))
	return h


def run(inpt):
	global data
	data = []
	for line in inpt.split('\n'):
		if not line: continue
		i = line.split('\t')
		data.append(
			[hash(i[0]), 
				  i[1], 
				  i[-1]=='*'])

def render():
	id = 0
	print('~~~')
	for i in data:
		print(f': ENTRY.{id}')
		print('d 0' if not id else f'r ENTRY.{id-1}')
		print(f'd {i[0]}')
		print(f'r {i[1]}')
		print(f'd {-i[2]}')
		id += 1
	print('\n: Latest')
	print(f'r ENTRY.{id-1}')
	print(': FREE-SPACE')
	print('~~~')



def save_to(fileName):
	a = '~~~\n'
	id = 0
	for i in data:
		a += f': ENTRY.{id}\n'
		a += 'd 0\n' if not id else f'r ENTRY.{id-1}\n'
		a += f'd {i[0]}\n'
		a += f'r {i[1]}\n'
		a += f'd {-i[2]}\n'
		id += 1
	a += '\n: Latest\n'
	a += f'r ENTRY.{id-1}\n'
	a += ': FREE-SPACE\n'
	a += '~~~\n'
	with open(fileName, 'w') as f:
		f.write(a)


with open('dict.data') as raw_inpt:
	run(raw_inpt.read())
#	render()
	save_to('forth.dictionary')

