/***************************************************************
                    __   ____ _  __ _
                    \ \ / / _` |/ _` |
                     \ V / (_| | (_| |
                      \_/ \__, |\__,_|
                          |___/  text mode
 ***************************************************************
 This is intended to provide a basic text mode display for ilo.
 It's not providing anything like cursor positioning, colors,
 etc.
 **************************************************************/

char* video  = (char*)0xb8000;

int tx, ty, ts;
I attr = 0x06;

void scroll() {
  for (ts = 0; ts < (80 * 24 * 2); ts += 2) {
    video[ts] = video[160 + ts];
  }
  for (; ts < (80 * 25 * 2); ts += 2) {
    video[ts] = 32;
  }

  for (ts = 1; ts < (80 * 24 * 2); ts += 2) {
    video[ts] = video[160 + ts];
  }
  for (; ts < (80 * 25 * 2); ts += 2) {
    video[ts] = attr;
  }
  ty = 24; tx = 0;
}

int cursor() {
  if (ty == 25) { scroll(); }

  unsigned short pos = (ty * 80) + tx;
  outb(0x3D4, 0x0F);
  outb(0x3D5, (unsigned short) (pos & 0xFF));
  outb(0x3D4, 0x0E);
  outb(0x3D5, (unsigned short) ((pos >> 8) & 0xFF));

  return ((ty * 80) + tx) * 2;
}

void next() {
  tx += 1;
  if (tx == 80) { tx = 0; ty += 1; }
}

void display(int c) {
  if (c == 10 || c == 13) { tx = 0; ty += 1; }
  else { video[cursor()] = (char)c;
         video[cursor() + 1] = attr; next(); }
  cursor();
}

// 1F = white on Blue

void vga_init() {
  attr = 0x06;
  for (tx = 0; tx < 80 * 25 * 2; tx += 2) { video[tx] = 32;   }
  for (tx = 1; tx < 80 * 25 * 2; tx += 2) { video[tx] = attr; }
  tx = 0; ty = 0;
  cursor();
}
